.NET
cancel
Showing results for 
Show  only  | Search instead for 
Did you mean: 

Attribute Definitions in BlockJig

2 REPLIES 2
SOLVED
Reply
Message 1 of 3
BrentBurgess1980
669 Views, 2 Replies

Attribute Definitions in BlockJig

Hey all,

 

I have a tool that inserts blocks using a jig, and it inserts the block, and attributes (if in the block), but the attributes do not go into the correct position.

 

The code below is the jig that I am using.

 

public class CBlockJig : EntityJig
        {
        private Point3d pos;
        private Dictionary<string, Point3d> attPos;
        private Transaction tr;

        public CBlockJig(Transaction transaction, BlockReference br)
            : base(br)
            {
            pos = br.Position;

            tr = transaction;

            // Initialize our dictionary with the tag /
            // AttributeDefinition position

            attPos = new Dictionary<string, Point3d>();

            BlockTableRecord btr = (BlockTableRecord)tr.GetObject(br.BlockTableRecord, OpenMode.ForRead);

            if (btr.HasAttributeDefinitions)
                {
                foreach (ObjectId id in btr)
                    {
                    DBObject obj = tr.GetObject(id, OpenMode.ForRead);
                    AttributeDefinition ad = obj as AttributeDefinition;

                    if (ad != null)
                        {
                        attPos.Add(ad.Tag, ad.Position);
                        }
                    }
                }
            }

        protected override bool Update()
            {
            BlockReference br = Entity as BlockReference;

            br.Position = pos;

            if (br.AttributeCollection.Count != 0)
                {
                foreach (ObjectId id in br.AttributeCollection)
                    {
                    DBObject obj = tr.GetObject(id, OpenMode.ForRead);
                    AttributeReference ar = obj as AttributeReference;

                    // Apply block transform to att def position

                    if (ar != null)
                        {
                        ar.UpgradeOpen();
                        ar.Position = attPos[ar.Tag].TransformBy(br.BlockTransform);
                        Point3d bpos = br.Position;
                        }
                    }
                }
            return true;
            }

        protected override SamplerStatus Sampler(JigPrompts prompts)
            {
            JigPromptPointOptions opts = new JigPromptPointOptions("\nSelect insertion point: ");
            opts.BasePoint = new Point3d(0, 0, 0);
            opts.UserInputControls = UserInputControls.NoZeroResponseAccepted;

            PromptPointResult ppr = prompts.AcquirePoint(opts);

            if (pos == ppr.Value)
                {
                return SamplerStatus.NoChange;
                }

            pos = ppr.Value;

            return SamplerStatus.OK;
            }

        public PromptStatus Run()
            {
            Document doc =
              Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;

            PromptResult promptResult = ed.Drag(this);
            return promptResult.Status;
            }
        }

 The Attributes appear in the right place while dragging, but once accepted and placed, the attribute is located as if the block were inserted at 0,0.

 

Does anyone have any clue on how to fix this?

 

Thanks

2 REPLIES 2
Message 2 of 3

Message 3 of 3

Thanks Gasty1001.

 

The code I was using was from Kean's site, which did the funny thing with the attribute.

 

I modified the spiderinnet1 one and it works well

 

Thanks

 

Can't find what you're looking for? Ask the community or share your knowledge.

Post to forums  

Autodesk DevCon in Munich May 28-29th


Autodesk Design & Make Report

”Boost